from rocolib.api.components import MechanicalComponent
from rocolib.api.composables import GraphComposable
from rocolib.api.ports import EdgePort
from rocolib.api.ports import FacePort


class FoldedComponent(MechanicalComponent):
  GRAPH = 'graph'

  def predefine(self, **kwargs):
    MechanicalComponent.predefine(self, **kwargs)

    g = GraphComposable()
    self.composables[self.GRAPH] = g

    self.place = self.getGraph().place
    self.mergeEdge = self.getGraph().mergeEdge
    self.addTab = self.getGraph().addTab
    self.getEdge = self.getGraph().getEdge
    self.attachEdge = self.getGraph().attachEdge
    self.addFace = self.getGraph().addFace
    self.attachFace = self.getGraph().attachFace

  def getGraph(self):
    return self.composables[self.GRAPH]

  def addEdgeInterface(self, interface, edges, lengths):
    self.addInterface(interface, None)
    self.setEdgeInterface(interface, edges, lengths)

  def addFaceInterface(self, interface, face):
    self.addInterface(interface, None)
    self.setFaceInterface(interface, face)

  def setEdgeInterface(self, interface, edges, lengths):
    self.setInterface(interface, EdgePort(self, edges, lengths))

  def setFaceInterface(self, interface, face):
    self.setInterface(interface, FacePort(self, self.getGraph(), face))
