from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addParameter("servo", "fs90r", paramType="dimension")
c.addParameter("flip", False, valueType="bool")
c.addParameter("center", True, valueType="bool")
c.addParameter("shift", 0, paramType="length")
c.addParameter("offset", optional=True)

c.addParameter("length", 10, paramType="length")
c.addParameter("width", 10, paramType="length")
c.addParameter("depth", 10, paramType="length")

c.addSubcomponent("beam", "RectBeam", inherit=True, prefix=None)
c.addSubcomponent("mount", "Cutout")

c.addConstraint(("beam", "width"), "depth")
c.addConstraint(("beam", "depth"), "width")

c.addConstraint(("beam", "minlength"), "servo", 'getDim(x, "motorlength") + getDim(x ,"shoulderlength") * 2')
c.addConstraint(("beam", "minwidth"), "servo", 'getDim(x, "motorwidth")')
c.addConstraint(("beam", "mindepth"), "servo", 'getDim(x, "motorheight")')

c.addConstraint(("mount", "dx"), "servo", 'getDim(x, "motorwidth") * 0.99')
c.addConstraint(("mount", "dy"), "servo", 'getDim(x, "motorlength")')

c.inheritAllInterfaces("beam", prefix=None)
c.inheritAllInterfaces("mount")
c.addConnection(("beam", "face2"),
                ("mount", "decoration"),
                mode="hole", offset=Function(params="offset"))

c.toLibrary("ServoMount")
